function [] = displayMesh2D(p, t)

% displayMesh2D - Display computational mesh.
%
% This QuickerSim CFD Toolbox function displays a 2-D computational mesh.
%
% displayMesh2D(p, t)
%
% Input arguments:
% p - array of nodal coordinates (see help of the importMeshGmsh function
%     for details).
% t - array of finite elements (see help of the importMeshGmsh function for
%     details).
%
% Visit also www.quickersim.com/cfd-toolbox-for-matlab/index and subscribe.
% You will get access to documentation, code examples, video and pdf
% tutorials. You can also ask for simple help at support@quickersim.com or
% buy dedicated, professional support service for your business.
% Check out also a list of currently on-going workshops and trainings with
% many additional examples, documentation and heat transfer applications.
% We also develop customized apps and offer on-site training for your team.
%
% See also: DISPLAYSOLUTION2D, IMPORTMESHGMSH.

nPnodes = max(max(t(1:3,:)));

trisurf(t(1:3,:)',p(1,1:nPnodes)',p(2,1:nPnodes)',zeros(nPnodes,1),zeros(nPnodes,1))
%colorbar
axis equal
view([0 90])
xlabel('x')
ylabel('y')

end